routes/web.php
<?php
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DashboardActiveController;
use App\Http\Controllers\SaleslogsController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\TvDashboardController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\SalesExportController;
use App\Http\Controllers\EmailingController;



/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check()) {
        return redirect('dashboard');
    }
    else
        return view('auth.login');
});


Route::middleware(['auth'])->group(function () {
Route::get('/dashboard',[DashboardController::class, 'index'])->name('dashboard');
Route::post('/dashboard',[DashboardController::class, 'index'])->name('dashboard');
Route::get('/dashboard-active',[DashboardActiveController::class, 'index'])->name('dashboard-active');
Route::post('/dashboard-active',[DashboardActiveController::class, 'index'])->name('dashboard-active');
Route::get('/tv-dashboard',[TvDashboardController::class, 'index']);
Route::get('/dashboard/salesman/{sm_name}',[DashboardController::class, 'salesman_details'])->name('salesman-details');
Route::post('/dashboard/salesman/{sm_name}',[DashboardController::class, 'salesman_details'])->name('salesman-details');
Route::get('/sales',[SaleslogsController::class, 'index'])->name('saleslogs');
Route::get('/wholesales',[SaleslogsController::class, 'WholeSales'])->name('wholesaleslogs');

Route::get('/dashboard/{date_range}/{file_type}/{tab_type}/{pifs_check}',[SalesExportController::class, 'index'])->name('export');

Route::get('sales/{id}',[SaleslogsController::class, 'showdetails'])->name('sales-view');

Route::get('/profile',[ProfileController::class, 'index'])->name('profile');
Route::resource('/user', UserController::class);

Route::get('/userReport',[UserController::class,'userReportview']);
});

Route::get('/emailsend/{time_range}',[EmailingController::class, 'emailsend'])->name('emailsend');
Route::get('/testemailsend',[EmailingController::class, 'testemailsend'])->name('testemailsend');


//Route::get('/profile-page', function(){
//return view('profile-page');
//})->middleware(['auth'])->name('view.profile');


require __DIR__.'/auth.php';

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'type',
        'password',
        'avatar',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\User;
use Illuminate\Auth\Events\Registered;
use Illuminate\Support\Facades\Hash;
use Image;


class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $users = User::all();
        /*echo '<pre>';
        print_r($users);*/

        return view('user.index',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        return view('user.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $filename = 'profile.png';
        if($request->hasFile('avatar'))
        {
            $avatar = $request->file('avatar');
            $filename = strtolower(substr($request->name,0,strpos($request->name, ' '))) . '.' . $avatar->getClientOriginalExtension();
            Image::make($avatar)->resize(300, 300)->save( public_path('/images/uploads/avatars/' . $filename ) );
        }

        $request->validate([
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255|unique:users',
            'password' => 'required|string|min:8',
            'password_confirmation' => 'required|same:password',
            'type' => 'required|string'
        ]);

        $user = User::create([
            'name' => $request->name,
            'email' => $request->email,
            'password' => Hash::make($request->password),
            'type' => $request->type,
            'avatar' => $filename
        ]);
        event(new Registered($user));
        return redirect()->route('user.index')->with('success', 'User created successfully!');

    }

      public function userReportview()
    {
            $users = User::all();
            return view('user.userReport',compact('users'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        $user = User::find($id);
        return view('user.edit', ['user' => $user]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $reports = $request->data_report;
        
        $daily_report ='0';
        $weekly_report ='0';
        $monthly_report ='0';
        if(!empty($reports))
        {
              if(in_array('weekly', $reports) )
        {
          $weekly_report ='1';
                }
            if(in_array('monthly', $reports))
            {
                $monthly_report ='1';
                    }
            if(in_array('daily', $reports))
              {
                $daily_report ='1';
                    }
        }
      
       // echo 'Daily Report--'.$daily_report."monthly-->".$monthly_report."weekly-->".$weekly_report;

        

        $request->validate([
            'type' => 'required|string',
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255'
        ]);

        $user = User::find($id);
        $user->name = $request->name;
        $user->type = $request->type;
        $user->email = $request->email;
        $user->daily_report = $daily_report;
        $user->weekly_report = $weekly_report;
        $user->monthly_report = $monthly_report;


        if($request->hasFile('avatar'))
        {
            $avatar = $request->file('avatar');
            $filename = strtolower(substr($request->name,0,strpos($request->name, ' '))) . '.' . $avatar->getClientOriginalExtension();
            Image::make($avatar)->resize(300, 300)->save( public_path('/images/uploads/avatars/' . $filename ) );
            $user->avatar = $filename;
        }

        if(!empty($request->password)){
        $user->password = Hash::make($request->password);
        }
        $user->save();

        return redirect()->route('user.index')->with('success', 'User updated successfully!');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
    
        $user = User::find($id);
        $user->delete();

        return redirect()->route('user.index')->with('success', 'User deleted successfully!');
    }


}

resources/views/user/create.blade.php
@include('common/header')

 
    <div class="slim-mainpanel">
      <div class="container">
      <div class="card mb-4">
            <div class="card-body">
                <form method="POST" action="{{route('user.store')}}" enctype="multipart/form-data">
                    @csrf

                <div class="row my-3">
                    <div class="col">
                    <div class="form-group1">
                        <label for="name">Name</label>
                        <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" id="name" placeholder="Enter name">
                        @error('name')
                        <small class="text-danger">{{$message}}</small>
                        @enderror
                    </div>
                </div>
                <div class="col input-group1">
                             <label for="use type">User Type</label>
                            <select class="custom-select @error('type') is-invalid @enderror" id="type" name="type">
                                <option value="">Select user type</option>
                                <option value="admin">Admin</option>
                                <option value="salesman">Sales Man</option>
                            </select>
                             @error('type')
                                <small class="text-danger">{{$message}}</small>
                             @enderror
                        </div>                
                </div>
                    
                    <div class="row my-3">
                        <div class="col input-group1">
                            <label for="email">Email Address</label>
                        <input type="email" class="form-control @error('email') is-invalid @enderror" name="email" id="email" placeholder="Enter email">
                        @error('email')
                        <small class="text-danger">{{$message}}</small>
                        @enderror
                        </div>                       
                    </div>

                    <div class="row my-3">
                        <div class="col">
                            <label for="password">Password</label>
                            <input type="password" class="form-control @error('password') is-invalid @enderror" name="password" id="password" placeholder="Enter password">
                            @error('password')
                            <small class="text-danger">{{$message}}</small>
                            @enderror
                        </div>
                        <div class="col">
                            <label for="password_confirmation">Confirm Password</label>
                            <input type="password" class="form-control @error('password_confirmation') is-invalid @enderror" name="password_confirmation" id="password_confirmation" placeholder="Enter confirm password">
                            @error('password_confirmation')
                            <small class="text-danger">{{$message}}</small>
                            @enderror
                        </div>
                    </div>
                    <div class="row my-3">
                        <div class="col">
                            <div class="input-group-prepend">
                                <button class="btn btn-outline-primary" id="generate" type="button">Generate</button>
                                <button class="btn btn-outline-info" id="showncopy" type="button">Show & Copy</button>
                            </div>
                           </div>
                           
                    </div>

                    <div class="row my-3">
                        <div class="col-6">
                            <input type="password" id="random-text" class="form-control" placeholder="Generate Random Password" aria-label="" aria-describedby="basic-addon1">
                        </div>
                    </div>



                    <div class="form-group">
                        <label for="profile_img">Profile Image</label>
                        <input style="border:none;width: auto;" type="file" name="avatar" id="profile_img" accept="image/*">
                    </div>
                    <button type="submit" class="btn btn-outline-primary">Add</button>
                </form>

            </div>
        </div>
      </div><!-- container -->
    </div><!-- slim-mainpanel -->


    @include('common/footer')
    <script>
    $(document).on("click", "button#generate", function() {
        var randomstring = Math.random().toString(36).slice(-10);
        $("input#random-text").val(randomstring);
    });

    $(document).on("click", "button#showncopy", function() {
        $("input#random-text").attr("type", "text")
        var randomText = $("input#random-text").val();
        $("input#password, input#password_confirmation").val(randomText);
        copyTextToClipboard();
    });

    function copyTextToClipboard() {
        var copyText = document.querySelector("input#random-text");
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        document.execCommand("copy");
        console.log("Copied the text: " + copyText.value);
    }
</script>
   
  

resources/views/user/edit.blade.php
@include('common/header')

 
    <div class="slim-mainpanel">
      <div class="container">
      <div class="row">
    <div class="col-md-10 offset-md-1">

        <!-- Default Card Example -->
        <div class="card mb-4">
            <div class="card-body">
                <form method="POST" action="{{route('user.update', [$user->id])}}" enctype="multipart/form-data">
                <input type="hidden" value="{{$user->id}}" name="id">
                    @csrf
                    @method('PUT')
                   
                  <div class="row my-3">
                    <div class="col">
                    <div class="form-group1">
                        <label for="name">Name</label>
                        <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" id="name" placeholder="Enter name" value="{{$user->name}}">
                        @error('name')
                        <small class="text-danger">{{$message}}</small>
                        @enderror
                    </div>
                    </div>
                    <div class="col input-group1">
                        <label for="use type">User Type</label>
                            <select class="custom-select @error('type') is-invalid @enderror" id="type" name="type">
                                <option value="">Select user type</option>
                                <option @if($user->type == 'admin') selected @endif value="admin">Admin</option>
                                <option @if($user->type == 'salesman') selected @endif value="salesman">Sales Man</option>
                            </select>
                             @error('type')
                        <small class="text-danger">{{$message}}</small>
                        @enderror
                        </div>
                       
                    </div>


                     <div class="row my-3">
                    <div class="col input-group1">
                        <label for="email">Email address</label>
                        <input type="email" class="form-control @error('email') is-invalid @enderror" name="email" id="email" placeholder="Enter email" value="{{$user->email}}">
                        @error('email')
                        <small class="text-danger">{{$message}}</small>
                        @enderror
                    </div>
                </div>
                    
                    
                    <div class="row my-3">
                        <div class="col">
                            <label for="password">Password</label>
                            <input type="password" class="form-control @error('password') is-invalid @enderror" name="password" id="password" placeholder="Enter password">
                            @error('password')
                            <small class="text-danger">{{$message}}</small>
                            @enderror
                        </div>
                        <div class="col">
                            <label for="password_confirmation">Confirm Password</label>
                            <input type="password" class="form-control @error('password_confirmation') is-invalid @enderror" name="password_confirmation" id="password_confirmation" placeholder="Enter confirm password">
                            @error('password_confirmation')
                            <small class="text-danger">{{$message}}</small>
                            @enderror
                        </div>
                    </div>

                    <div class="row my-3">
                       <div class="col">
                            <div class="input-group-prepend">
                                <button class="btn btn-outline-primary" id="generate" type="button">Generate</button>
                                <button class="btn btn-outline-info" id="showncopy" type="button">Show & Copy</button>
                            </div>
                           
                        </div>
                    </div>
                    <div class="row my-3">
                        <div class="col-6">
                             <input type="password" id="random-text" class="form-control" placeholder="Generate Random Password" aria-label="" aria-describedby="basic-addon1">
                        </div>


                      

                        <div class="col-6">
                          <div class="row">
                            <div class="col-3">
                      <label for="password_confirmation">Report</label>   
                                </div>
                            <div class="col-9">                     
                         <input type="checkbox" name="data_report[]" id="pifs_checkbox" <?php if($user->daily_report =='1') echo "checked";?> value="daily">Daily
                      <input type="checkbox" name="data_report[]" id="pifs_checkbox" <?php if($user->weekly_report =='1') echo "checked"; ?> value="weekly">Weekly
                      <input type="checkbox" name="data_report[]" id="pifs_checkbox" <?php if($user->monthly_report =='1') echo "checked"; ?> value="monthly">Monthly
                                       </div>
                             </div>
                        </div>
                    </div>


                    <div class="form-group">
                        <label for="profile_img">Profile Image</label>
                        <input style="border:none; width: auto;" type="file" name="avatar" id="profile_img" accept="image/*">
                    </div>
                    <button type="submit" class="btn btn-outline-primary">Update</button>
                </form>
            </div>
        </div>

    </div>
</div>
      </div><!-- container -->
    </div><!-- slim-mainpanel -->

    @include('common/footer')
    <script>
    $(document).on("click", "button#generate", function() {
        var randomstring = Math.random().toString(36).slice(-10);
        $("input#random-text").val(randomstring);
    });

    $(document).on("click", "button#showncopy", function() {
        $("input#random-text").attr("type", "text")
        var randomText = $("input#random-text").val();
        $("input#password, input#password_confirmation").val(randomText);
        copyTextToClipboard();
    });

    function copyTextToClipboard() {
        var copyText = document.querySelector("input#random-text");
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        document.execCommand("copy");
        console.log("Copied the text: " + copyText.value);
    }
</script>
   
  

resources/views/user/index.blade.php
@include('common/header')


 
    <div class="slim-mainpanel">
      <div class="container">
        <div class="slim-pageheader">
          <ol class="breadcrumb slim-breadcrumb">
            <li class="breadcrumb-item"><a href="#">Home</a></li>
            <li class="breadcrumb-item"><a href="#">User</a></li>
          </ol>
          <h6 class="slim-pagetitle"><a href="{{route('user.create')}}"> Add Users</a></h6>
        </div><!-- slim-pageheader -->

        <div class="section-wrapper mg-t-20">
          <label class="section-title">All Users</label>
        
          <div class="table-wrapper">
            <table id="datatable2" class="table display responsive nowrap">
              <thead>
                <tr>
                  <th class="wd-15p">Users</th>
                  <th class="wd-15p">User Type</th>
                  <th class="wd-20p">Email</th>
                  <th class="wd-15p">Create Date</th>
                  <th class="wd-10p">Update Date</th>
                  <th class="wd-10p">Method</th>
                </tr>
              </thead>
              <tbody>
              @foreach($users as $key=>$user)
                <tr>
                  <td><span class="all-users"><img src="{{ asset('/public/images/uploads/avatars/'.$user->avatar)}}"></span>{{$user->name}}</td>
                  <td>{{$user->type}}</td>
                  <td>{{$user->email}}</td>
                  <td>{{$user->created_at}}</td>
                  <td>{{$user->updated_at}}</td>
                  <td>@if(Auth::user()->id != $user->id)
                            <a href="{{ route('user.edit', [$user->id]) }}" class="btn btn-outline-primary edit-btn">Edit <i class="fa fa-pencil" aria-hidden="true"></i></a>
                            <button data-toggle="modal" data-target="#deleteModal" class="btn btn-outline-danger delete-btn" data-route="{{ route('user.destroy', [$user->id]) }}"><i class="fa fa-trash-o" aria-hidden="true"></i></button>
                            @else
                            <a href="{{ route('user.edit', [$user->id]) }}" class="btn btn-outline-primary edit-btn">Edit <i class="fa fa-pencil" aria-hidden="true"></i></a>
                            @endif
                  </td>
                </tr>
                @endforeach
                
              </tbody>
            </table>
          </div><!-- table-wrapper -->
        </div><!-- section-wrapper -->
        <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                Press "Delete" below if you are ready to delete.
            </div>
            <div class="modal-footer">
                <form id="delete" method="POST" action="">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    </div>
</div>
      </div><!-- container -->
    </div><!-- slim-mainpanel -->

    @include('common/footer')
  
    <script>
      $(function(){
        'use strict';

        $('#datatable1').DataTable({
          responsive: true,
          language: {
            searchPlaceholder: 'Search...',
            sSearch: '',
            lengthMenu: '_MENU_ items/page',
          }
        });

        $('#datatable2').DataTable({
          bLengthChange: false,
          searching: false,
          responsive: true
        });

        // Select2
        $('.dataTables_length select').select2({ minimumResultsForSearch: Infinity });

      });
    </script>
    <script>
    $(document).on("click", "button.delete-btn", function() {
        var deleteRoute = $(this).data("route");
        console.log(deleteRoute);
        $("form#delete").attr("action", deleteRoute);
        return true;
    });
</script>
  

resources/views/user/userReport.blade.php
@include('common/header')
@include('common/navbar')

 
    <div class="slim-mainpanel">
      <div class="container">
        <div class="slim-pageheader">
          <ol class="breadcrumb slim-breadcrumb">
            <li class="breadcrumb-item"><a href="#">Home</a></li>
            <li class="breadcrumb-item"><a href="#">User Report</a></li>
          </ol>
          <h6 class="slim-pagetitle"><a href="{{route('user.create')}}"> Add Users</a></h6>
        </div><!-- slim-pageheader -->

        <div class="section-wrapper mg-t-20">
          <label class="section-title">All Users</label>
        
          <div class="table-wrapper">
            <table id="datatable2" class="table display responsive nowrap">
              <thead>
                <tr>
                  <th class="wd-15p">Users</th>
                  <!-- <th class="wd-15p">User Type</th> -->
                  <th class="wd-20p">Email</th>
                  <th class="wd-20p">Report</th>
            <!--  <th class="wd-15p">Create Date</th>
                  <th class="wd-10p">Update Date</th>
                  <th class="wd-10p">Method</th> -->
                </tr>
              </thead>
              <tbody>
              @foreach($users as $key=>$user)
                <tr>
                  <td><span class="all-users"><img src="{{ asset('/public/images/uploads/avatars/'.$user->avatar)}}"></span>{{$user->name}}</td>
                  <!-- <td>{{$user->type}}</td> -->
                  <td>{{$user->email}}</td>
                  <td><?php echo (($user->data_report!=null)?$user->data_report:'N/A')?></td>

                 <!--  <td>{{$user->created_at}}</td>
                  <td>{{$user->updated_at}}</td> -->
                 <!--  <td>@if(Auth::user()->id != $user->id)
                            <a href="{{ route('user.edit', [$user->id]) }}" class="btn btn-outline-primary edit-btn">Edit <i class="fa fa-pencil" aria-hidden="true"></i></a>
                            <button data-toggle="modal" data-target="#deleteModal" class="btn btn-outline-danger delete-btn" data-route="{{ route('user.destroy', [$user->id]) }}"><i class="fa fa-trash-o" aria-hidden="true"></i></button>
                            @else
                            <a href="{{ route('user.edit', [$user->id]) }}" class="btn btn-outline-primary edit-btn">Edit <i class="fa fa-pencil" aria-hidden="true"></i></a>
                            @endif
                  </td> -->
                </tr>
                @endforeach
                
              </tbody>
            </table>
          </div><!-- table-wrapper -->
        </div><!-- section-wrapper -->
        <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                Press "Delete" below if you are ready to delete.
            </div>
            <div class="modal-footer">
                <form id="delete" method="POST" action="">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    </div>
</div>
      </div><!-- container -->
    </div><!-- slim-mainpanel -->

    @include('common/footer')
  
    <script>
      $(function(){
        'use strict';

        $('#datatable1').DataTable({
          responsive: true,
          language: {
            searchPlaceholder: 'Search...',
            sSearch: '',
            lengthMenu: '_MENU_ items/page',
          }
        });

        $('#datatable2').DataTable({
          bLengthChange: false,
          searching: false,
          responsive: true
        });

        // Select2
        $('.dataTables_length select').select2({ minimumResultsForSearch: Infinity });

      });
    </script>
    <script>
    $(document).on("click", "button.delete-btn", function() {
        var deleteRoute = $(this).data("route");
        console.log(deleteRoute);
        $("form#delete").attr("action", deleteRoute);
        return true;
    });
</script>
  